Attribute VB_Name = "Module1"
Option Explicit

Public targetCtl

'Dim targetCtl As ComboBox
'Dim targetCtl As ListBox

Public Const LOCALE_SLANGUAGE As Long = &H2    'localized name of language
Public Const LOCALE_SSHORTDATE As Long = &H1F    'short date format string
Public Const LOCALE_SLONGDATE As Long = &H20    'long date format string
Public Const DATE_LONGDATE As Long = &H2
Public Const DATE_SHORTDATE As Long = &H1
Public Const HWND_BROADCAST As Long = &HFFFF&
Public Const WM_SETTINGCHANGE As Long = &H1A

Public Declare Function PostMessage Lib "user32" _
        Alias "PostMessageA" _
        (ByVal hwnd As Long, _
        ByVal wMsg As Long, _
        ByVal wParam As Long, _
        lParam As Any) As Long

Public Declare Function EnumDateFormats Lib "kernel32" _
        Alias "EnumDateFormatsA" _
        (ByVal lpDateFmtEnumProc As Long, _
        ByVal Locale As Long, _
        ByVal dwFlags As Long) As Long

Public Declare Sub CopyMemory Lib "kernel32" _
        Alias "RtlMoveMemory" _
        (Destination As Any, _
        Source As Any, _
        ByVal Length As Long)

Public Declare Function GetSystemDefaultLCID Lib "kernel32" () As Long

Public Declare Function GetLocaleInfo Lib "kernel32" _
        Alias "GetLocaleInfoA" _
        (ByVal Locale As Long, _
        ByVal LCType As Long, _
        ByVal lpLCData As String, _
        ByVal cchData As Long) As Long

Public Declare Function SetLocaleInfo Lib "kernel32" _
        Alias "SetLocaleInfoA" _
        (ByVal Locale As Long, _
        ByVal LCType As Long, _
        ByVal lpLCData As String) As Long


Public Function GetUserLocaleInfo(ByVal dwLocaleID As Long, _
                                  ByVal dwLCType As Long) As String
    Dim sReturn As String
    Dim r As Long

    'call the function passing the Locale type
    'variable to retrieve the required size of
    'the string buffer needed
    r = GetLocaleInfo(dwLocaleID, dwLCType, sReturn, Len(sReturn))

    'if successful..
    If r Then
        'pad the buffer with spaces
        sReturn = Space$(r)
        'and call again passing the buffer
        r = GetLocaleInfo(dwLocaleID, dwLCType, sReturn, Len(sReturn))
        'if successful (r > 0)
        If r Then
            'r holds the size of the string
            'including the terminating null
            GetUserLocaleInfo = Left$(sReturn, r - 1)
        End If
    End If
End Function

Public Function EnumCalendarDateProc(DateFormatString As Long) As Long
'application-defined callback function for EnumDateFormats
'populates combo assigned to global var targetCtl
    targetCtl.AddItem StringFromPointer(DateFormatString)

    'return 1 to continue enumeration
    EnumCalendarDateProc = 1
End Function

Private Function StringFromPointer(lpString As Long) As String
    Dim pos As Long
    Dim buffer As String

    'pad a string to hold the data
    buffer = Space$(128)

    'copy the string pointed to by the return value
    CopyMemory ByVal buffer, lpString, ByVal Len(buffer)

    'remove the trailing null and trim
    pos = InStr(buffer, Chr$(0))

    If pos Then
        StringFromPointer = Left$(buffer, pos - 1)
    End If
End Function


